<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>AMC13: /work/dan/AMC13/amc13-fw/src/common/TTS/encode_8b10b_pkg.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">AMC13
   </div>
   <div id="projectbrief">Firmwares for the different applications of the AMC13 uTCA board made at Boston University</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li><li class="navelem"><a class="el" href="dir_b77d6eb5e54ee39b9fd0963f258f0094.html">TTS</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">encode_8b10b_pkg.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">---------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">--  Module      : encode_8b10b_pkg.vhd</span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">--  Version     : </span><span class="vhdllogic">1</span>.<span class="vhdllogic">1</span><span class="keyword"></span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">--  Last Update : 2008-10-31</span><span class="keyword"></span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">--  Project     : 8b/10b Encoder Reference Design</span><span class="keyword"></span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">--  Description : 8b/10b Encoder <span class="vhdlkeyword">package</span> <span class="vhdlkeyword">file</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">--  Company     : Xilinx, Inc.</span><span class="keyword"></span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">--  DISCLAIMER <span class="vhdlkeyword">OF</span> LIABILITY</span><span class="keyword"></span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">--                This <span class="vhdlkeyword">file</span> contains proprietary <span class="vhdlkeyword">and</span> confidential information <span class="vhdlkeyword">of</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">--                Xilinx, Inc. (</span><span class="keyword">&quot;Xilinx&quot;</span>), that <span class="vhdlkeyword">is</span> distributed under a license<span class="keyword"></span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">--                from Xilinx, <span class="vhdlkeyword">and</span> may be used, copied and/or disclosed only</span><span class="keyword"></span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">--                pursuant <span class="vhdlkeyword">to</span> the terms <span class="vhdlkeyword">of</span> a valid license agreement <span class="vhdlkeyword">with</span> Xilinx.</span><span class="keyword"></span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">--                XILINX <span class="vhdlkeyword">IS</span> PROVIDING THIS DESIGN, CODE, <span class="vhdlkeyword">OR</span> INFORMATION</span><span class="keyword"></span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">--                (</span><span class="keyword">&quot;MATERIALS&quot;</span>) &quot;AS IS&quot; WITHOUT WARRANTY <span class="vhdlkeyword">OF</span> ANY KIND, EITHER<span class="keyword"></span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">--                EXPRESSED, IMPLIED, <span class="vhdlkeyword">OR</span> STATUTORY, INCLUDING WITHOUT</span><span class="keyword"></span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">--                LIMITATION, ANY WARRANTY <span class="vhdlkeyword">WITH</span> RESPECT <span class="vhdlkeyword">TO</span> NONINFRINGEMENT,</span><span class="keyword"></span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">--                MERCHANTABILITY <span class="vhdlkeyword">OR</span> FITNESS <span class="vhdlkeyword">FOR</span> ANY PARTICULAR PURPOSE. Xilinx</span><span class="keyword"></span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">--                does <span class="vhdlkeyword">not</span> warrant that functions included <span class="vhdlkeyword">in</span> the Materials will</span><span class="keyword"></span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">--                meet the requirements <span class="vhdlkeyword">of</span> Licensee, <span class="vhdlkeyword">or</span> that the operation <span class="vhdlkeyword">of</span> the</span><span class="keyword"></span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">--                Materials will be uninterrupted <span class="vhdlkeyword">or</span> error-free, <span class="vhdlkeyword">or</span> that defects</span><span class="keyword"></span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">--                <span class="vhdlkeyword">in</span> the Materials will be corrected.  Furthermore, Xilinx does</span><span class="keyword"></span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">--                <span class="vhdlkeyword">not</span> warrant <span class="vhdlkeyword">or</span> make any representations regarding <span class="vhdlkeyword">use</span>, <span class="vhdlkeyword">or</span> the</span><span class="keyword"></span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">--                results <span class="vhdlkeyword">of</span> the <span class="vhdlkeyword">use</span>, <span class="vhdlkeyword">of</span> the Materials <span class="vhdlkeyword">in</span> terms <span class="vhdlkeyword">of</span> correctness,</span><span class="keyword"></span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">--                accuracy, reliability <span class="vhdlkeyword">or</span> otherwise.</span><span class="keyword"></span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">--                Xilinx products are <span class="vhdlkeyword">not</span> designed <span class="vhdlkeyword">or</span> intended <span class="vhdlkeyword">to</span> be fail-safe,</span><span class="keyword"></span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">--                <span class="vhdlkeyword">or</span> <span class="vhdlkeyword">for</span> <span class="vhdlkeyword">use</span> <span class="vhdlkeyword">in</span> any application requiring fail-safe performance,</span><span class="keyword"></span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">--                such as life-support <span class="vhdlkeyword">or</span> safety devices <span class="vhdlkeyword">or</span> systems, Class III</span><span class="keyword"></span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">--                medical devices, nuclear facilities, applications related <span class="vhdlkeyword">to</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">--                the deployment <span class="vhdlkeyword">of</span> airbags, <span class="vhdlkeyword">or</span> any other applications that could</span><span class="keyword"></span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">--                lead <span class="vhdlkeyword">to</span> death, personal injury <span class="vhdlkeyword">or</span> severe <span class="vhdlkeyword">property</span> <span class="vhdlkeyword">or</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">--                environmental damage (individually <span class="vhdlkeyword">and</span> collectively, &quot;critical</span><span class="keyword"></span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">--                applications&quot;).  Customer assumes the sole risk <span class="vhdlkeyword">and</span> liability</span><span class="keyword"></span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">--                <span class="vhdlkeyword">of</span> any <span class="vhdlkeyword">use</span> <span class="vhdlkeyword">of</span> Xilinx products <span class="vhdlkeyword">in</span> critical applications,</span><span class="keyword"></span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">--                subject only <span class="vhdlkeyword">to</span> applicable laws <span class="vhdlkeyword">and</span> regulations governing</span><span class="keyword"></span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">--                limitations <span class="vhdlkeyword">on</span> product liability.</span><span class="keyword"></span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">--                Copyright </span><span class="vhdllogic">2000</span>, <span class="vhdllogic">2001</span>, <span class="vhdllogic">2002</span>, <span class="vhdllogic">2003</span>, <span class="vhdllogic">2004</span>, <span class="vhdllogic">2008</span> Xilinx, Inc.<span class="keyword"></span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">--                <span class="vhdlkeyword">All</span> rights reserved.</span><span class="keyword"></span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">--                This disclaimer <span class="vhdlkeyword">and</span> copyright notice must be retained as part</span><span class="keyword"></span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">--                <span class="vhdlkeyword">of</span> this <span class="vhdlkeyword">file</span> at <span class="vhdlkeyword">all</span> times.</span><span class="keyword"></span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">---------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">--  History</span><span class="keyword"></span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">--  Date        Version   Description</span><span class="keyword"></span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">--  10/31/2008  </span><span class="vhdllogic">1</span>.<span class="vhdllogic">1</span>       Initial <span class="vhdlkeyword">release</span><span class="keyword"></span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="vhdlkeyword">LIBRARY </span><span class="keywordflow">IEEE</span>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="vhdlkeyword">USE </span>IEEE.STD_LOGIC_1164.<span class="vhdlkeyword">ALL</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="vhdlkeyword">USE </span>IEEE.std_logic_misc.<span class="vhdlkeyword">ALL</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="vhdlkeyword">USE </span>STD.textio.<span class="vhdlkeyword">ALL</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Package</span> Declaration</span><span class="keyword"></span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00071"></a><span class="lineno"><a class="code" href="classencode__8b10b__pkg.html">   71</a></span>&#160;<span class="keywordflow">PACKAGE </span><a class="code" href="classencode__8b10b__pkg.html">encode_8b10b_pkg</a> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Constant</span> Declaration</span><span class="keyword"></span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="vhdlkeyword">CONSTANT</span> <span class="vhdlchar">TFF</span> <span class="vhdlchar">:</span> <span class="comment">time</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">2</span> <span class="vhdlchar">ns</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Function</span> Declarations</span><span class="keyword"></span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> concat_force_code(</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    force_code_disp : <span class="comment">INTEGER</span>; force_code_val : <span class="comment">STRING</span>)</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">STRING</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> str_to_slv(</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    bitsin : <span class="comment">STRING</span>; nbits : <span class="comment">INTEGER</span>)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">STD_LOGIC_VECTOR</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> boolean_to_std_logic(</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    value : <span class="comment">BOOLEAN</span>)</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> bint_2_sl (</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    X : <span class="comment">INTEGER</span>)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> has_bport (</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    C_HAS_BPORTS : <span class="comment">INTEGER</span>; has_aport : <span class="comment">INTEGER</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    ) <span class="vhdlkeyword">RETURN</span> <span class="comment">INTEGER</span>;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="vhdlkeyword">END</span> <span class="vhdlchar">encode_8b10b_pkg</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">Package</span> <span class="vhdlkeyword">Body</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="code" href="class__encode__8b10b__pkg.html">  102</a></span>&#160;<span class="vhdlkeyword">PACKAGE</span> <span class="vhdlkeyword">BODY</span> <a class="code" href="classencode__8b10b__pkg.html">encode_8b10b_pkg</a> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">-- Determine initial value <span class="vhdlkeyword">of</span> DOUT based <span class="vhdlkeyword">on</span> C_FORCE_CODE_DISP <span class="vhdlkeyword">and</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">-- C_FORCE_CODE_VAL</span><span class="keyword"></span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> concat_force_code(</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    force_code_disp : <span class="comment">INTEGER</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    force_code_val  : <span class="comment">STRING</span>)</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">STRING</span> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="vhdlkeyword">VARIABLE</span> tmp  : <span class="comment">STRING</span> <span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">TO</span> <span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;  <span class="vhdlkeyword">BEGIN</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="vhdlkeyword">IF</span> <span class="vhdlchar">(</span>force_code_disp = <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;      tmp := <span class="vhdllogic">&quot;01&quot;</span> &amp; force_code_val;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="vhdlkeyword">ELSE</span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;      tmp := <span class="vhdllogic">&quot;00&quot;</span> &amp; force_code_val;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="vhdlkeyword">RETURN</span> tmp;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;  <span class="vhdlkeyword">END</span> concat_force_code;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword">-- Converts a <span class="comment">STRING</span> containing 1&#39;s <span class="vhdlkeyword">and</span> 0&#39;s into a <span class="comment">STD_LOGIC_VECTOR</span> <span class="vhdlkeyword">of</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">--  width nbits.</span><span class="keyword"></span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> str_to_slv(bitsin : <span class="comment">STRING</span>; nbits : <span class="comment">INTEGER</span>)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">STD_LOGIC_VECTOR</span> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="vhdlkeyword">VARIABLE</span> ret       : <span class="comment">STD_LOGIC_VECTOR</span><span class="vhdlchar">(</span>bitsin&#39;<span class="vhdlkeyword">range</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="vhdlkeyword">VARIABLE</span> ret0s     : <span class="comment">STD_LOGIC_VECTOR</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">TO</span> nbits<span class="vhdlchar">)</span> := <span class="vhdlchar">(</span><span class="vhdlkeyword">OTHERS</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;<span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="vhdlkeyword">VARIABLE</span> retpadded : <span class="comment">STD_LOGIC_VECTOR</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">TO</span> nbits<span class="vhdlchar">)</span> := <span class="vhdlchar">(</span><span class="vhdlkeyword">OTHERS</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;<span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="vhdlkeyword">VARIABLE</span> offset    : <span class="comment">INTEGER</span> := <span class="vhdllogic"></span><span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  <span class="vhdlkeyword">BEGIN</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="vhdlkeyword">IF</span><span class="vhdlchar">(</span>bitsin&#39;length = <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span><span class="keyword"> -- Make all &#39;0&#39;s</span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      <span class="vhdlkeyword">RETURN</span> ret0s;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="vhdlkeyword">IF</span><span class="vhdlchar">(</span>bitsin&#39;length &lt; nbits<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span><span class="keyword"> -- pad MSBs with &#39;0&#39;s</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;      offset := nbits - bitsin&#39;length;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;      <span class="vhdlkeyword">FOR</span> i <span class="vhdlkeyword">IN</span> bitsin&#39;<span class="vhdlkeyword">range</span> <span class="vhdlkeyword">LOOP</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="vhdlkeyword">IF</span> bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;<span class="vhdllogic"></span><span class="vhdllogic">1</span>&#39; <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;          retpadded<span class="vhdlchar">(</span>i+offset<span class="vhdlchar">)</span> := &#39;<span class="vhdllogic"></span><span class="vhdllogic">1</span>&#39;;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="vhdlkeyword">ELSIF</span> <span class="vhdlchar">(</span>bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;X&#39; <span class="vhdlkeyword">OR</span> bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;x&#39;<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;          retpadded<span class="vhdlchar">(</span>i+offset<span class="vhdlchar">)</span> := &#39;X&#39;;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="vhdlkeyword">ELSIF</span> <span class="vhdlchar">(</span>bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;Z&#39; <span class="vhdlkeyword">OR</span> bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;z&#39;<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;          retpadded<span class="vhdlchar">(</span>i+offset<span class="vhdlchar">)</span> := &#39;Z&#39;;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="vhdlkeyword">ELSIF</span> <span class="vhdlchar">(</span>bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;          retpadded<span class="vhdlchar">(</span>i+offset<span class="vhdlchar">)</span> := &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;      <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">LOOP</span>;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;      retpadded<span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">TO</span> offset<span class="vhdlchar">)</span> := <span class="vhdlchar">(</span><span class="vhdlkeyword">OTHERS</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;<span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;      <span class="vhdlkeyword">RETURN</span> retpadded;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="vhdlkeyword">FOR</span> i <span class="vhdlkeyword">IN</span> bitsin&#39;<span class="vhdlkeyword">range</span> <span class="vhdlkeyword">LOOP</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;      <span class="vhdlkeyword">IF</span> bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;<span class="vhdllogic"></span><span class="vhdllogic">1</span>&#39; <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        ret<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> := &#39;<span class="vhdllogic"></span><span class="vhdllogic">1</span>&#39;;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      <span class="vhdlkeyword">ELSIF</span> <span class="vhdlchar">(</span>bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;X&#39; <span class="vhdlkeyword">OR</span> bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;x&#39;<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        ret<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> := &#39;X&#39;;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;      <span class="vhdlkeyword">ELSIF</span> <span class="vhdlchar">(</span>bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;Z&#39; <span class="vhdlkeyword">OR</span> bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;z&#39;<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        ret<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> := &#39;Z&#39;;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      <span class="vhdlkeyword">ELSIF</span> <span class="vhdlchar">(</span>bitsin<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> = &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        ret<span class="vhdlchar">(</span>i<span class="vhdlchar">)</span> := &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;      <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">LOOP</span>;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="vhdlkeyword">RETURN</span> ret;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;  <span class="vhdlkeyword">END</span> str_to_slv;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="keyword">  -- This <span class="vhdlkeyword">function</span> takes <span class="vhdlkeyword">in</span> a <span class="comment">boolean</span> value <span class="vhdlkeyword">and</span> returns</span><span class="keyword"></span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="keyword">  -- a <span class="comment">STD_LOGIC</span> &#39;0&#39; <span class="vhdlkeyword">or</span> &#39;1&#39;</span><span class="keyword"></span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> boolean_to_std_logic(value : <span class="comment">BOOLEAN</span>) <span class="vhdlkeyword">RETURN</span> <span class="comment">STD_LOGIC</span> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;  <span class="vhdlkeyword">BEGIN</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="vhdlkeyword">IF</span> <span class="vhdlchar">(</span>value=TRUE<span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;      <span class="vhdlkeyword">RETURN</span> &#39;<span class="vhdllogic"></span><span class="vhdllogic">1</span>&#39;;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="vhdlkeyword">ELSE</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;      <span class="vhdlkeyword">RETURN</span> &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;  <span class="vhdlkeyword">END</span> boolean_to_std_logic;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="keyword">-- Converts a binary <span class="comment">integer</span> (</span><span class="vhdllogic">0</span> <span class="vhdlkeyword">or</span> <span class="vhdllogic">1</span>) <span class="vhdlkeyword">to</span> a <span class="comment">std_logic</span> binary value.<span class="keyword"></span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> bint_2_sl (X : <span class="comment">INTEGER</span>) <span class="vhdlkeyword">RETURN</span> <span class="comment">STD_LOGIC</span> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;  <span class="vhdlkeyword">BEGIN</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="vhdlkeyword">IF</span> <span class="vhdlchar">(</span>X = <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;      <span class="vhdlkeyword">RETURN</span> &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="vhdlkeyword">ELSE</span></div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;      <span class="vhdlkeyword">RETURN</span> &#39;<span class="vhdllogic"></span><span class="vhdllogic">1</span>&#39;;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;  <span class="vhdlkeyword">END</span> bint_2_sl;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="keyword">-----------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">If</span> C_HAS_BPORTS = </span><span class="vhdllogic">1</span>, <span class="vhdlkeyword">then</span> the optional B ports are configured the<span class="keyword"></span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="keyword">-- same as the optional A ports</span><span class="keyword"></span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">If</span> C_HAS_BPORTS = </span><span class="vhdllogic">0</span>, <span class="vhdlkeyword">then</span> the optional B ports are disabled (= <span class="vhdllogic">0</span>)<span class="keyword"></span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="keyword">-----------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;  <span class="vhdlkeyword">FUNCTION</span> has_bport (</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    C_HAS_BPORTS : <span class="comment">INTEGER</span>;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    has_aport    : <span class="comment">INTEGER</span>)</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="vhdlkeyword">RETURN</span> <span class="comment">INTEGER</span> <span class="vhdlkeyword">IS</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <span class="vhdlkeyword">VARIABLE</span> has_bport : <span class="comment">INTEGER</span>;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;  <span class="vhdlkeyword">BEGIN</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="vhdlkeyword">IF</span> <span class="vhdlchar">(</span>C_HAS_BPORTS = <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">THEN</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;      has_bport := has_aport;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="vhdlkeyword">ELSE</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;      has_bport := <span class="vhdllogic"></span><span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">IF</span>;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="vhdlkeyword">RETURN</span> has_bport;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;  <span class="vhdlkeyword">END</span> has_bport;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="vhdlkeyword">END</span> <span class="vhdlchar">encode_8b10b_pkg</span>;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Sep 8 2021 11:22:41 for AMC13 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
